;-------------------------------------------------------------------------
; AltKey v1.0
; (C) 1993
; Lasse R. Nielsen
; lrn@daimi.aau.dk
; Compile with TASM (Borland Turbo-Assembler)
;-------------------------------------------------------------------------
.MODEL  compact
.8086
ALT_PRESS       equ     56
ALT_RELEASE     equ     184

CODE    SEGMENT 'code'
        ASSUME cs:CODE,ds:NOTHING,es:NOTHING
ORG 00h
main:
                        cmp     AH,4FH
                        je      not_right_through
                        jmp     right_through
not_right_through:
                        mov     cs:buffer,ax
                        push    ds
                        push    ax
                        mov     ax,cs
                        mov     ds,ax
        ASSUME  ds:CODE
                        pop     ax

                        dec     byte ptr flags
                        jne     last_not_extended
                        inc     byte ptr flags
                        jmp     go_go_go
last_not_extended:
                        cmp     al,224
                        jne     not_extended_key
                        inc     byte ptr flags
                        jmp     go_go_go
not_extended_key:

                        mov     ah,12h
                        int     16h
                        and     ah,02h
                        je      go_go_go
;left alt IS pressed
                        mov     al,byte ptr buffer
                        cmp     al,0b8h         ;alt-released
                        jne     not_alt_release
                        mov     al,byte ptr  [flags+1] ;anything to write?
                        or      al,al
                        je      go_go_go

                        push    cx
                        mov     cl,value
                        xor     ch,ch
                        mov     ah,05h
                        int     16h
                        pop     cx
                        or      al,al
                        je      write_ok

write_ok:
                        xor     ah,ah
                        mov     value,ah
                        mov byte ptr [flags+1],ah
                        jmp     go_go_go

not_alt_release:
                        dec     al
                        je      go_go_go
                        cmp     al,0ah
                        ja      go_go_go
                        jb      not_nul
                        xor     al,al
not_nul:
                        xchg    al,value
                        mov     ah,0ah
                        mul     ah
                        add     value,al
but_not_zero:
                        inc     byte ptr [flags+1]
                        je      but_not_zero
                        mov byte ptr [buffer],38h

go_go_go:
                        mov     ax,buffer
                        stc
                        pop     ds
        ASSUME  ds:NOTHING
right_through:
                        jmp dword ptr cs:[ole_vector]
ole_vector              dw ?,?
value                   db ?
buffer                  dw ?
flags                   dw 0

prog_end:
CODE    ENDS

INIT    SEGMENT 'code'
        ASSUME cs:INIT,ds:_DATA,es:NOTHING
start:
                        mov     ah,30h          ;Only if DOS-VER>=3.0
                        int     21h             ;
                        xchg    al,ah           ;
                        cmp     ax,0300h        ;
                        jae     go_resident     ;
                        mov     ax,4cffh        ;  else exit errorlevel 1
                        int     21h             ;
go_resident:
                        mov             ah,62h          ; get psp segment in bx
                        int             21h             ;
                        mov             es,bx
                        mov             ax,es:[2ch]     ; get environment-seg in ax
                        cmp             ax,00h          ;  if !=0 release
                        je              no_release      ;  .
                        mov word ptr    es:[2ch],0      ; dump environment
                        mov             es,ax           ; release memory
                        mov             ah,49h          ; .
                        int             21h             ; .
    ;release environment in hope that it will leave room for resident part
no_release:
                        mov             ah,48h          ;Allocate block for resident part!
                        mov             bx,(((prog_end-main)+15)/16);ye ole length
                        int             21h             ;.
                        jnc             enough_mem_available
                        mov             ax,4c08h
                        int             21h
enough_mem_available:
                        mov             cs:new_seg,ax

                        mov             cx,(offset prog_end); move resident part to new block
                        mov             es,ax
                        mov             ax,CODE
                        mov             ds,ax                             ; .
        ASSUME  ds:NOTHING
                        mov             si,0                              ; .
                        mov             di,0                              ; .
                        cld                                               ; .
                        rep     movsb                                     ; .



                        mov             ax,3515h        ;get old int15 vector
                        int             21h                     ;

                        mov             ax,cs:new_seg
                        mov             ds,ax
        ASSUME ds:NOTHING

                        mov             ds:[offset ole_vector],bx         ;
                        mov             ds:[offset ole_vector+2],es       ;


                        mov             dx,0                    ;set new vector
                        mov             ax,2515h                ;.(ds:dx)
                        int             21h                     ;.

                        mov             ax,ds          ;changer owner id
                        dec             ax             ;of mcb of resident
                        mov             ds,ax          ;part to command.com
                        mov word ptr    ds:[1],0008h   ;

                        mov             ax,INIT
                        mov             ds,ax
                        mov             dx,offset IntroText
                        mov             ah,09h
                        int             21h

                        mov             ax,4c00h        ;leave well enough alone
                        int             21h             ;
new_seg                 dw      ?
IntroText       db      'AltKey (C) 1993 by Spot/Triangle 3532',0dh,0ah,'$'
INIT    ENDS
        END start

